﻿extern alias e2;
extern alias e1;

using n8 = e2::VL.Lib.Collections;
using n16 = _CoreLibBasics_.Control;
using n7 = _System_Serialization_.System.Serialization.Volatile.Advanced;
using n4 = global::System.Collections.Generic;
using n10 = _System_Serialization_.System.Serialization;
using n11 = _VL_Xml_.System.XML;
using n1 = e2::VL.Core;
using n3 = global::System;
using n14 = e2::VL.Lib.IO;
using n2 = e2::VL.Core.CompilerServices;
using n13 = e1::VL.Lib.IO;
using n6 = e1::VL.Lib.Runtime;
using n15 = global::System.Runtime.CompilerServices;
using n12 = _System_Serialization_.System.Serialization.Advanced;
using n9 = _VL_Collections_.Collections.Spread;
using n5 = global::System.Xml.Linq;

namespace _System_Serialization_.System.Serialization.Advanced
{
    public static partial class _Operations_
    {
        public static void Serialize<T>(n1.SerializationContext Input_In, string Name_In, T Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Force_Element_In, out n3.Object Result_Out)
        {
            var Result_0 = n1.Serialization.Serialize<T>(context: Input_In, name: Name_In, value: Value_In, forceElement: Force_Element_In);
            Result_Out = Result_0;
            return;
        }

        public static void Deserialize<T>(n1.SerializationContext Input_In, n3.Object Content_In, string Name_In, out T Result_Out)
        {
            var Result_0 = n1.Serialization.Deserialize<T>(context: Input_In, content: Content_In, name: Name_In);
            Result_Out = Result_0;
            return;
        }

        public static void RegisterSerializer<T2, T>(n1.IVLFactory Input_In, T2 Serializer_In, out n1.IVLFactory Output_Out)
            where T2 : class, n1.ISerializer<T>
        {
            var Output_0 = n1.Serialization.RegisterSerializer<T, T2>(factory: Input_In, serializer: Serializer_In);
            Output_Out = Output_0;
            return;
        }

        public static void Serialize_Log_Errors<T>(T Value_In, bool Throw_On_Error_In, bool Include_Defaults_In, n1.NodeContext Node_Context_In, out n5.XElement Result_Out, out n4.IReadOnlyList<string> Error_Messages_Out)
        {
            var Result_1 = n1.Serialization.Serialize<T>(nodeContext: Node_Context_In, value: Value_In, throwOnError: Throw_On_Error_In, includeDefaults: Include_Defaults_In, errorMessages: out n4.IReadOnlyList<string> Error_Messages_0);
            Result_Out = Result_1;
            Error_Messages_Out = Error_Messages_0;
            return;
        }

        public static void Deserialize_Log_Errors<T>(n5.XElement Content_In, bool Throw_On_Error_In, n1.NodeContext Node_Context_In, out T Result_Out, out n4.IReadOnlyList<string> Error_Messages_Out)
        {
            var Result_1 = n1.Serialization.Deserialize<T>(nodeContext: Node_Context_In, content: Content_In, throwOnError: Throw_On_Error_In, errorMessages: out n4.IReadOnlyList<string> Error_Messages_0);
            Result_Out = Result_1;
            Error_Messages_Out = Error_Messages_0;
            return;
        }
    }
}

namespace _System_Serialization_.System.Serialization.Volatile.Advanced
{
    public static partial class _Operations_
    {
        public static void Deserialize_Binary_ReadOnlyMemory<T>(n3.ReadOnlyMemory<byte> Serialized_Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Force_Little_Endian_In, out T Result_Out)
        {
            var Result_0 = n6.Serialization.DeserializeBinary<T>(serializedValue: Serialized_Value_In, forceLittleEndian: Force_Little_Endian_In);
            Result_Out = Result_0;
            return;
        }

        public static void Deserialize_Bson<T>(byte[] Serialized_Value_In, out T Result_Out)
        {
            var Result_0 = n6.Serialization.DeserializeBson<T>(serializedValue: Serialized_Value_In);
            Result_Out = Result_0;
            return;
        }

        public static void Deserialize_Json_Slicewise<T2, T>(T2 Serialized_Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, [n2.SerializedDefaultValueAttribute("True", false)] bool Omit_Header_In, out n8.Spread<T> Result_Out)
            where T2 : n4.IEnumerable<string>
        {
            n8.Spread<T> __cp_A0lDo2EFiUUMOSU0fxGA8s = n9._Operations_.CreateDefault<T>();
            var builder_5 = n2.CollectionBuilders.GetBuilder(__cp_A0lDo2EFiUUMOSU0fxGA8s, 16);
            n8.Spread<T> output_6;
            try
            {
                var i_2 = 0;
                foreach (var item_0 in Serialized_Value_In)
                {
                    var splicer_1 = item_0;
                    var i_local_3 = i_2;
                    n7._Operations_.Deserialize_Json<T>(Serialized_Value_In: splicer_1, Indent_In: Indent_In, Omit_Header_In: Omit_Header_In, Result_Out: out T Result_4);
                    builder_5.Add(Result_4);
                    i_2++;
                }
            }
            finally
            {
                output_6 = builder_5.Commit();
            }

            Result_Out = output_6;
            return;
        }

        public static void Deserialize_Json<T>(string Serialized_Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, [n2.SerializedDefaultValueAttribute("True", false)] bool Omit_Header_In, out T Result_Out)
        {
            var Result_0 = n6.Serialization.DeserializeJson<T>(serializedValue: Serialized_Value_In, indent: Indent_In, omitHeader: Omit_Header_In);
            Result_Out = Result_0;
            return;
        }

        public static void Deserialize_Xml_Slicewise<T2, T>(T2 Serialized_Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, out n8.Spread<T> Result_Out)
            where T2 : n4.IEnumerable<string>
        {
            n8.Spread<T> __cp_MuiOKfhXQIgLRhy8RxSTkT = n9._Operations_.CreateDefault<T>();
            var builder_5 = n2.CollectionBuilders.GetBuilder(__cp_MuiOKfhXQIgLRhy8RxSTkT, 16);
            n8.Spread<T> output_6;
            try
            {
                var i_2 = 0;
                foreach (var item_0 in Serialized_Value_In)
                {
                    var splicer_1 = item_0;
                    var i_local_3 = i_2;
                    n7._Operations_.Deserialize_Xml<T>(Serialized_Value_In: splicer_1, Indent_In: Indent_In, Result_Out: out T Result_4);
                    builder_5.Add(Result_4);
                    i_2++;
                }
            }
            finally
            {
                output_6 = builder_5.Commit();
            }

            Result_Out = output_6;
            return;
        }

        public static void Deserialize_Xml<T>(string Serialized_Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, out T Result_Out)
        {
            var Result_0 = n6.Serialization.DeserializeXml<T>(serializedValue: Serialized_Value_In, indent: Indent_In);
            Result_Out = Result_0;
            return;
        }

        public static void Serialize_Binary<T>(T Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Force_Little_Endian_In, out byte[] Result_Out)
        {
            var Result_0 = n6.Serialization.SerializeBinary<T>(value: Value_In, forceLittleEndian: Force_Little_Endian_In);
            Result_Out = Result_0;
            return;
        }

        public static void Serialize_Bson<T>(T Value_In, out byte[] Result_Out)
        {
            var Result_0 = n6.Serialization.SerializeBson<T>(value: Value_In);
            Result_Out = Result_0;
            return;
        }

        public static void Serialize_Json_Slicewise<T2, T>(T2 Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, [n2.SerializedDefaultValueAttribute("True", false)] bool Omit_Header_In, out n8.Spread<string> Result_Out)
            where T2 : n4.IEnumerable<T>
        {
            n8.Spread<string> __cp_JanpLebjo8LPQBZGcwt9oG = n9._Operations_.CreateDefault<string>();
            var builder_5 = n2.CollectionBuilders.GetBuilder(__cp_JanpLebjo8LPQBZGcwt9oG, 16);
            n8.Spread<string> output_6;
            try
            {
                var i_2 = 0;
                foreach (var item_0 in Value_In)
                {
                    var splicer_1 = item_0;
                    var i_local_3 = i_2;
                    n7._Operations_.Serialize_Json<T>(Value_In: splicer_1, Indent_In: Indent_In, Omit_Header_In: Omit_Header_In, Result_Out: out string Result_4);
                    builder_5.Add(Result_4);
                    i_2++;
                }
            }
            finally
            {
                output_6 = builder_5.Commit();
            }

            Result_Out = output_6;
            return;
        }

        public static void Serialize_Json<T>(T Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, [n2.SerializedDefaultValueAttribute("True", false)] bool Omit_Header_In, out string Result_Out)
        {
            var Result_0 = n6.Serialization.SerializeJson<T>(value: Value_In, indent: Indent_In, omitHeader: Omit_Header_In);
            Result_Out = Result_0;
            return;
        }

        public static void Serialize_Xml_Slicewise<T2, T>(T2 Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, out n8.Spread<string> Result_Out)
            where T2 : n4.IEnumerable<T>
        {
            n8.Spread<string> __cp_PrbNeUqfkOtLRnzJDf51wO = n9._Operations_.CreateDefault<string>();
            var builder_5 = n2.CollectionBuilders.GetBuilder(__cp_PrbNeUqfkOtLRnzJDf51wO, 16);
            n8.Spread<string> output_6;
            try
            {
                var i_2 = 0;
                foreach (var item_0 in Value_In)
                {
                    var splicer_1 = item_0;
                    var i_local_3 = i_2;
                    n7._Operations_.Serialize_Xml<T>(Value_In: splicer_1, Indent_In: Indent_In, Result_Out: out string Result_4);
                    builder_5.Add(Result_4);
                    i_2++;
                }
            }
            finally
            {
                output_6 = builder_5.Commit();
            }

            Result_Out = output_6;
            return;
        }

        public static void Serialize_Xml<T>(T Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Indent_In, out string Result_Out)
        {
            var Result_0 = n6.Serialization.SerializeXml<T>(value: Value_In, indent: Indent_In);
            Result_Out = Result_0;
            return;
        }

        public static void Deserialize_Binary<T>(byte[] Serialized_Value_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Force_Little_Endian_In, out T Result_Out)
        {
            var Result_0 = n6.Serialization.DeserializeBinary<T>(serializedValue: Serialized_Value_In, forceLittleEndian: Force_Little_Endian_In);
            Result_Out = Result_0;
            return;
        }
    }
}

namespace _System_Serialization_.System.Serialization
{
    [n1.ElementAttribute(TracingId = 133881U, DocumentId = "UNgTG11dj1YPpT6hEzII3u", PersistentId = "Ordux5u8MUjPFUJ6OrYaW1", Name = "Persistent_Ordux5u8MUjPFUJ6OrYaW1")]
    [n3.SerializableAttribute]
    public sealed class Persistent_Ordux5u8MUjPFUJ6OrYaW1 : n1.VLObject<n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1>, n3.IDisposable
    {
        [n2.CreateNewAttribute]
        public static n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 Create(n1.NodeContext Node_Context)
        {
            var instance = new Persistent_Ordux5u8MUjPFUJ6OrYaW1(Node_Context, n1.VLObject.NewIdentity());
            return instance.__Create__(Node_Context);
        }

        [n2.CreateDefaultAttribute]
        public static n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 CreateDefault()
        {
            var instance = new Persistent_Ordux5u8MUjPFUJ6OrYaW1(n1.NodeContext.Default, n1.VLObject.NewIdentity());
            return instance.__CreateDefault__();
        }

        public n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 Update<T>(T Input_In, n14.Path File_Path_In, bool Write_In, bool Read_In, [n2.SerializedDefaultValueAttribute("True", false)] bool Read_On_Open_In, bool Include_Defaults_In, bool Throw_On_Error_In, out T Output_Out)
        {
            T __auto_0;
            var state_1 = n1.CompilationHelper.Restore<__GkuB5GyITVHLundXagPzp1>(this.__if_IZtGDxZ2OKpOxt9hKfN5kX, __GetContext__());
            if (Write_In)
            {
                if (state_1 == null)
                {
                    state_1 = new __GkuB5GyITVHLundXagPzp1();
                    n1.NodeContext Node_Context_2 = __GetContext__().CreateSubContext("UNgTG11dj1YPpT6hEzII3u", "UnlXPYKa5aGN6lIq6KKvJM", 134532U);
                    var Output_3 = n11.XMLWriter_K3RuV8m5vRVMCM7TAI7w2R.Create(Node_Context: Node_Context_2);
                    state_1.__p_UnlXPYKa5aGN6lIq6KKvJM = Output_3;
                }

                n1.NodeContext Node_Context_4 = __GetContext__().CreateSubContext("UNgTG11dj1YPpT6hEzII3u", "ILvsEteerFZOvvTwNNv0D6", 134565U);
                n12._Operations_.Serialize_Log_Errors<T>(Value_In: Input_In, Throw_On_Error_In: Throw_On_Error_In, Include_Defaults_In: Include_Defaults_In, Node_Context_In: Node_Context_4, Result_Out: out n5.XElement Result_5, Error_Messages_Out: out n4.IReadOnlyList<string> Error_Messages_6);
                File_Path_In.Filename(directory: out string Directory_7, filename: out string Filename_8, extension: out string Extension_9);
                var Result_10 = n13.PathExtension.ToPath(input: Directory_7);
                bool Create_11 = true;
                var Output_13 = n13.PathExtension.CreateDirectory(input: Result_10, create: Create_11, success: out bool Success_12);
                bool Update_14 = true;
                var Output_15 = state_1.__p_UnlXPYKa5aGN6lIq6KKvJM;
                if (Update_14)
                {
                    Output_15 = state_1.__p_UnlXPYKa5aGN6lIq6KKvJM.Update(File_Path_In: File_Path_In, Data_In: Result_5, Write_In: Success_12);
                }

                __auto_0 = Input_In;
                if (this.__GetContext__().IsImmutable)
                    state_1 = Output_15 != state_1.__p_UnlXPYKa5aGN6lIq6KKvJM ? new __GkuB5GyITVHLundXagPzp1(state_1)
                    {__p_UnlXPYKa5aGN6lIq6KKvJM = Output_15} : state_1;
                else
                {
                    state_1.__p_UnlXPYKa5aGN6lIq6KKvJM = Output_15;
                }
            }
            else
            {
                __auto_0 = Input_In;
            }

            bool Simulate_16 = false;
            var State_Output_18 = this.__p_O3mvYre01AZN3OprmuM0tI.Update(Simulate_In: Simulate_16, Output_Out: out bool Output_17);
            var Output_19 = Output_17 && Read_On_Open_In;
            var Output_20 = Read_In || Output_19;
            T __auto_21;
            var state_22 = n1.CompilationHelper.Restore<__TGEDNkvadi7OP4nui6VkVH>(this.__if_GVDuzkAA4l4LB2vIVjhCxS, __GetContext__());
            if (Output_20)
            {
                if (state_22 == null)
                {
                    state_22 = new __TGEDNkvadi7OP4nui6VkVH();
                }

                var Exists_23 = File_Path_In.Exists;
                T __auto_24;
                var state_25 = n1.CompilationHelper.Restore<__OJGA3ZpwsH2QaJjRjVZDHE>(state_22.__if_BcQIhjMVqwDOiWwb56cTSZ, __GetContext__());
                if (Exists_23)
                {
                    if (state_25 == null)
                    {
                        state_25 = new __OJGA3ZpwsH2QaJjRjVZDHE();
                        n1.NodeContext Node_Context_26 = __GetContext__().CreateSubContext("UNgTG11dj1YPpT6hEzII3u", "HlqiQ7qZc7VP1n3nprAeNO", 134048U);
                        var Output_27 = n11.XMLReader_OcM6yTDIunKLXht5WzCyyW.Create(Node_Context: Node_Context_26);
                        state_25.__p_HlqiQ7qZc7VP1n3nprAeNO = Output_27;
                    }

                    var State_Output_29 = state_25.__p_HlqiQ7qZc7VP1n3nprAeNO.Update(File_Path_In: File_Path_In, Read_In: Output_20, Output_Out: out n5.XElement Output_28);
                    n1.NodeContext Node_Context_30 = __GetContext__().CreateSubContext("UNgTG11dj1YPpT6hEzII3u", "AgN3vcL20sSORif2Ostttr", 134119U);
                    n12._Operations_.Deserialize_Log_Errors<T>(Content_In: Output_28, Throw_On_Error_In: Throw_On_Error_In, Node_Context_In: Node_Context_30, Result_Out: out T Result_31, Error_Messages_Out: out n4.IReadOnlyList<string> Error_Messages_32);
                    __auto_24 = Result_31;
                    if (this.__GetContext__().IsImmutable)
                        state_25 = State_Output_29 != state_25.__p_HlqiQ7qZc7VP1n3nprAeNO ? new __OJGA3ZpwsH2QaJjRjVZDHE(state_25)
                        {__p_HlqiQ7qZc7VP1n3nprAeNO = State_Output_29} : state_25;
                    else
                    {
                        state_25.__p_HlqiQ7qZc7VP1n3nprAeNO = State_Output_29;
                    }
                }
                else
                {
                    __auto_24 = __auto_0;
                }

                __auto_21 = __auto_24;
                if (this.__GetContext__().IsImmutable)
                    state_22 = state_25 != state_22.__if_BcQIhjMVqwDOiWwb56cTSZ ? new __TGEDNkvadi7OP4nui6VkVH(state_22)
                    {__if_BcQIhjMVqwDOiWwb56cTSZ = state_25} : state_22;
                else
                {
                    state_22.__if_BcQIhjMVqwDOiWwb56cTSZ = state_25;
                }
            }
            else
            {
                __auto_21 = __auto_0;
            }

            Output_Out = __auto_21;
            n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 that_33 = this;
            if (this.__GetContext__().IsImmutable)
                that_33 = state_1 != this.__if_IZtGDxZ2OKpOxt9hKfN5kX || State_Output_18 != this.__p_O3mvYre01AZN3OprmuM0tI || state_22 != this.__if_GVDuzkAA4l4LB2vIVjhCxS ? new n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1(this)
                {__if_IZtGDxZ2OKpOxt9hKfN5kX = state_1, __p_O3mvYre01AZN3OprmuM0tI = State_Output_18, __if_GVDuzkAA4l4LB2vIVjhCxS = state_22} : that_33;
            else
            {
                this.__if_IZtGDxZ2OKpOxt9hKfN5kX = state_1;
                this.__p_O3mvYre01AZN3OprmuM0tI = State_Output_18;
                this.__if_GVDuzkAA4l4LB2vIVjhCxS = state_22;
            }

            return that_33;
        }

        public n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 __Create__(n1.NodeContext Node_Context)
        {
            n15.RuntimeHelpers.EnsureSufficientExecutionStack();
            n1.NodeContext Node_Context_0 = Node_Context.CreateSubContext("UNgTG11dj1YPpT6hEzII3u", "O3mvYre01AZN3OprmuM0tI", 134423U);
            var Output_1 = n16.OnOpen_FuW9Q3o4A1QLNwSJwTBGFz.Create(Node_Context: Node_Context_0);
            n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 that_2 = this;
            this.__p_O3mvYre01AZN3OprmuM0tI = Output_1;
            this.__if_IZtGDxZ2OKpOxt9hKfN5kX = default(n3.Object);
            this.__if_GVDuzkAA4l4LB2vIVjhCxS = default(n3.Object);
            return that_2;
        }

        public n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 __CreateDefault__()
        {
            n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 that_0 = this;
            this.__if_IZtGDxZ2OKpOxt9hKfN5kX = default(n3.Object);
            this.__p_O3mvYre01AZN3OprmuM0tI = n16.OnOpen_FuW9Q3o4A1QLNwSJwTBGFz.CreateDefault();
            this.__if_GVDuzkAA4l4LB2vIVjhCxS = default(n3.Object);
            return that_0;
        }

        public void Dispose()
        {
            n1.CompilationHelper.SafeDispose(this.__if_IZtGDxZ2OKpOxt9hKfN5kX);
            n1.CompilationHelper.SafeDispose(this.__p_O3mvYre01AZN3OprmuM0tI);
            n1.CompilationHelper.SafeDispose(this.__if_GVDuzkAA4l4LB2vIVjhCxS);
            return;
        }

        [n1.ElementAttribute(IsManaged = true, IsAutoGenerated = true)]
        public n3.Object __if_IZtGDxZ2OKpOxt9hKfN5kX;
        [n1.ElementAttribute(TracingId = 134423U, DocumentId = "UNgTG11dj1YPpT6hEzII3u", PersistentId = "O3mvYre01AZN3OprmuM0tI", Name = "OnOpen", IsManaged = true, IsAutoGenerated = true)]
        public n16.OnOpen_FuW9Q3o4A1QLNwSJwTBGFz __p_O3mvYre01AZN3OprmuM0tI;
        [n1.ElementAttribute(IsManaged = true, IsAutoGenerated = true)]
        public n3.Object __if_GVDuzkAA4l4LB2vIVjhCxS;
        [n3.SerializableAttribute]
        sealed class __GkuB5GyITVHLundXagPzp1 : n3.IDisposable
        {
            [n1.ElementAttribute(TracingId = 134532U, DocumentId = "UNgTG11dj1YPpT6hEzII3u", PersistentId = "UnlXPYKa5aGN6lIq6KKvJM", Name = "XMLWriter", IsManaged = true, IsAutoGenerated = true)]
            public n11.XMLWriter_K3RuV8m5vRVMCM7TAI7w2R __p_UnlXPYKa5aGN6lIq6KKvJM;
            public __GkuB5GyITVHLundXagPzp1()
            {
            }

            public __GkuB5GyITVHLundXagPzp1(__GkuB5GyITVHLundXagPzp1 other)
            {
                this.__p_UnlXPYKa5aGN6lIq6KKvJM = other.__p_UnlXPYKa5aGN6lIq6KKvJM;
            }

            void n3.IDisposable.Dispose()
            {
                n1.CompilationHelper.SafeDispose(this.__p_UnlXPYKa5aGN6lIq6KKvJM);
            }
        }

        [n3.SerializableAttribute]
        sealed class __TGEDNkvadi7OP4nui6VkVH : n3.IDisposable
        {
            [n1.ElementAttribute(IsManaged = true, IsAutoGenerated = true)]
            public n3.Object __if_BcQIhjMVqwDOiWwb56cTSZ;
            public __TGEDNkvadi7OP4nui6VkVH()
            {
            }

            public __TGEDNkvadi7OP4nui6VkVH(__TGEDNkvadi7OP4nui6VkVH other)
            {
                this.__if_BcQIhjMVqwDOiWwb56cTSZ = other.__if_BcQIhjMVqwDOiWwb56cTSZ;
            }

            void n3.IDisposable.Dispose()
            {
                n1.CompilationHelper.SafeDispose(this.__if_BcQIhjMVqwDOiWwb56cTSZ);
            }
        }

        [n3.SerializableAttribute]
        sealed class __OJGA3ZpwsH2QaJjRjVZDHE : n3.IDisposable
        {
            [n1.ElementAttribute(TracingId = 134048U, DocumentId = "UNgTG11dj1YPpT6hEzII3u", PersistentId = "HlqiQ7qZc7VP1n3nprAeNO", Name = "XMLReader", IsManaged = true, IsAutoGenerated = true)]
            public n11.XMLReader_OcM6yTDIunKLXht5WzCyyW __p_HlqiQ7qZc7VP1n3nprAeNO;
            public __OJGA3ZpwsH2QaJjRjVZDHE()
            {
            }

            public __OJGA3ZpwsH2QaJjRjVZDHE(__OJGA3ZpwsH2QaJjRjVZDHE other)
            {
                this.__p_HlqiQ7qZc7VP1n3nprAeNO = other.__p_HlqiQ7qZc7VP1n3nprAeNO;
            }

            void n3.IDisposable.Dispose()
            {
                n1.CompilationHelper.SafeDispose(this.__p_HlqiQ7qZc7VP1n3nprAeNO);
            }
        }

        void n3.IDisposable.Dispose()
        {
            using var __current_services = __GetServiceRegistry__().MakeCurrentIfNone();
            Dispose();
        }

        public Persistent_Ordux5u8MUjPFUJ6OrYaW1(): base()
        {
        }

        public Persistent_Ordux5u8MUjPFUJ6OrYaW1(n1.NodeContext context, uint identity): base(context, identity)
        {
        }

        public Persistent_Ordux5u8MUjPFUJ6OrYaW1(Persistent_Ordux5u8MUjPFUJ6OrYaW1 other): base(other)
        {
            this.__if_IZtGDxZ2OKpOxt9hKfN5kX = other.__if_IZtGDxZ2OKpOxt9hKfN5kX;
            this.__p_O3mvYre01AZN3OprmuM0tI = other.__p_O3mvYre01AZN3OprmuM0tI;
            this.__if_GVDuzkAA4l4LB2vIVjhCxS = other.__if_GVDuzkAA4l4LB2vIVjhCxS;
        }

        protected override n1.IVLObject __With__(n4.IReadOnlyDictionary<string, n3.Object> values)
        {
            return __WITH__(n1.CompilationHelper.GetValueOrExisting(values, "__if_IZtGDxZ2OKpOxt9hKfN5kX", in __if_IZtGDxZ2OKpOxt9hKfN5kX), n1.CompilationHelper.GetValueOrExisting(values, "__p_O3mvYre01AZN3OprmuM0tI", in __p_O3mvYre01AZN3OprmuM0tI), n1.CompilationHelper.GetValueOrExisting(values, "__if_GVDuzkAA4l4LB2vIVjhCxS", in __if_GVDuzkAA4l4LB2vIVjhCxS));
        }

        internal Persistent_Ordux5u8MUjPFUJ6OrYaW1 __WITH__(n3.Object __if_IZtGDxZ2OKpOxt9hKfN5kX, n16.OnOpen_FuW9Q3o4A1QLNwSJwTBGFz __p_O3mvYre01AZN3OprmuM0tI, n3.Object __if_GVDuzkAA4l4LB2vIVjhCxS)
        {
            n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1 that_0 = this;
            if (this.__GetContext__().IsImmutable)
                that_0 = __if_IZtGDxZ2OKpOxt9hKfN5kX != this.__if_IZtGDxZ2OKpOxt9hKfN5kX || __p_O3mvYre01AZN3OprmuM0tI != this.__p_O3mvYre01AZN3OprmuM0tI || __if_GVDuzkAA4l4LB2vIVjhCxS != this.__if_GVDuzkAA4l4LB2vIVjhCxS ? new n10.Persistent_Ordux5u8MUjPFUJ6OrYaW1(this)
                {__if_IZtGDxZ2OKpOxt9hKfN5kX = __if_IZtGDxZ2OKpOxt9hKfN5kX, __p_O3mvYre01AZN3OprmuM0tI = __p_O3mvYre01AZN3OprmuM0tI, __if_GVDuzkAA4l4LB2vIVjhCxS = __if_GVDuzkAA4l4LB2vIVjhCxS} : that_0;
            else
            {
                this.__if_IZtGDxZ2OKpOxt9hKfN5kX = __if_IZtGDxZ2OKpOxt9hKfN5kX;
                this.__p_O3mvYre01AZN3OprmuM0tI = __p_O3mvYre01AZN3OprmuM0tI;
                this.__if_GVDuzkAA4l4LB2vIVjhCxS = __if_GVDuzkAA4l4LB2vIVjhCxS;
            }

            return that_0;
        }
    }

    [n1.ElementAttribute(TracingId = 135102U, DocumentId = "UNgTG11dj1YPpT6hEzII3u", PersistentId = "Im8eY6kiq8sPbl841Co0vs", Name = "System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs")]
    [n3.SerializableAttribute]
    public sealed class System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs : n1.VLObject<n10.System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs>, n3.IDisposable
    {
        [n2.CreateNewAttribute]
        public static n10.System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs Create(n1.NodeContext Node_Context)
        {
            var instance = new System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs(Node_Context, n1.VLObject.NewIdentity());
            return instance.__Create__(Node_Context);
        }

        [n2.CreateDefaultAttribute]
        public static n10.System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs CreateDefault()
        {
            var instance = new System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs(n1.NodeContext.Default, n1.VLObject.NewIdentity());
            return instance.__CreateDefault__();
        }

        public n10.System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs Update()
        {
            return this;
        }

        public n10.System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs __Create__(n1.NodeContext Node_Context)
        {
            n15.RuntimeHelpers.EnsureSufficientExecutionStack();
            return this;
        }

        public n10.System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs __CreateDefault__()
        {
            return this;
        }

        public void Dispose()
        {
            return;
        }

        void n3.IDisposable.Dispose()
        {
            using var __current_services = __GetServiceRegistry__().MakeCurrentIfNone();
            Dispose();
        }

        public System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs(): base()
        {
        }

        public System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs(n1.NodeContext context, uint identity): base(context, identity)
        {
        }

        public System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs(System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs other): base(other)
        {
        }

        protected override n1.IVLObject __With__(n4.IReadOnlyDictionary<string, n3.Object> values)
        {
            return __WITH__();
        }

        internal System_SerializationApplication_Im8eY6kiq8sPbl841Co0vs __WITH__()
        {
            return this;
        }
    }

    public static partial class _Operations_
    {
        public static void Serialize<T>(T Value_In, n1.NodeContext Node_Context_In, [n2.SerializedDefaultValueAttribute("False", false)] bool Include_Defaults_In, out n5.XElement Result_Out)
        {
            var Result_0 = n1.Serialization.Serialize<T>(nodeContext: Node_Context_In, value: Value_In, includeDefaults: Include_Defaults_In);
            Result_Out = Result_0;
            return;
        }

        public static void Deserialize<T>(n5.XElement Content_In, n1.NodeContext Node_Context_In, out T Result_Out)
        {
            var Result_0 = n1.Serialization.Deserialize<T>(nodeContext: Node_Context_In, content: Content_In);
            Result_Out = Result_0;
            return;
        }
    }
}

namespace _System_Serialization_
{
    public struct __AdaptiveImplementations__UNgTG11dj1YPpT6hEzII3u
    {
    }
}